#!/usr/bin/perl
#
# script to switch on S.M.A.R.T. and detect disk using -d
#
# $Id: detect_smart.pl 283 2007-10-18 13:27:01Z weizen_42 $
#

use strict;


my $hdd_device = "/dev/harddisk";
my $path_smartctl = "/usr/local/sbin/smartctl";


# smartctl installed ?
exit 0 unless ( -e "$path_smartctl" );


my $smart_output = "";
my $smart_option = "";

$smart_output = `$path_smartctl -iHA $hdd_device | grep "with the -d option"`;

goto OPTION1_DONE if ( $smart_output eq "" );
$smart_option = "-d sat";
$smart_output = `$path_smartctl -iHA $smart_option $hdd_device | grep "SMART support is: Available"`;
goto OPTION1_DONE if ( $smart_output ne "" );

$smart_option = "-d ata";
$smart_output = `$path_smartctl -iHA $smart_option $hdd_device | grep "SMART support is: Available"`;
goto OPTION1_DONE if ( $smart_output ne "" );

$smart_option = "-d scsi";
$smart_output = `$path_smartctl -iHA $smart_option $hdd_device | grep "SMART support is: Available"`;
goto OPTION1_DONE if ( $smart_output ne "" );

$smart_option = "";

OPTION1_DONE:

open (CONFIGFILE, ">/var/ipcop/hddgraph/settings");
print CONFIGFILE <<END
SMARTCTL_OPTIONS=$smart_option
END
;
close CONFIGFILE;

$smart_output = `$path_smartctl -iHA $smart_option $hdd_device | grep "SMART support is: Disabled"`;
system("$path_smartctl -s on $hdd_device >/dev/null") if ( $smart_output ne "" );
