#!/usr/bin/perl
#
################################################################################
#
# IPCop HDDGraph Web-Iface
#
# Copyright (C) 2006-2007 Olaf (weizen_42) Westrik
#
# This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version. 
#
# This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. 
#
# You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA 
#
#
# Dieses Programm ist freie Software. Sie knnen es unter den Bedingungen der GNU General Public License, wie von der Free Software Foundation verffentlicht, weitergeben und/oder modifizieren, entweder gem Version 2 der Lizenz oder (nach Ihrer Option) jeder spteren Version. 
#
# Die Verffentlichung dieses Programms erfolgt in der Hoffnung, da es Ihnen von Nutzen sein wird, aber OHNE IRGENDEINE GARANTIE, sogar ohne die implizite Garantie der MARKTREIFE oder der VERWENDBARKEIT FR EINEN BESTIMMTEN ZWECK. Details finden Sie in der GNU General Public License. 
#
# Sie sollten ein Exemplar der GNU General Public License zusammen mit diesem Programm erhalten haben. Falls nicht, schreiben Sie an die Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110, USA.
#
################################################################################
#
# For support post / read in http://www.ipcop-forum.de
#
# $Id: hddgraph.cgi 282 2007-10-18 13:26:31Z weizen_42 $
#
# Based on IPCop http://www.ipcop.org graphs.cgi which is partly (c) The SmoothWall Team
#
#
# 2006-02-23 modified by weizen_42 for hddgraphs
# 2006-02-xx weizen_42        several modifications
# 2006-03-31 weizen_42        link to homepage
# 2006-04-22 weizen_42        v0.1.1 install below proxygraphs in status menu
# 2006-05-26 weizen_42        v0.2.0 included smartctl output (if present)
# 2006-10-05 weizen_42        v0.3.0 check for new version
# 2007-01-14 weizen_42        v0.3.1 display hddtemp / Smartctl version
#

use strict;

# enable only the following on debugging purpose
use warnings;
use CGI::Carp 'fatalsToBrowser';

use LWP::UserAgent;

require '/var/ipcop/general-functions.pl';
require "${General::swroot}/lang.pl";
require "${General::swroot}/header.pl";

my $version = 'v0.4.0';
my $hddtempversion = `/usr/sbin/hddtemp -v | /usr/bin/cut -d ' ' -f 3`;
my $smartctlversion = `/usr/local/sbin/smartctl -V | /bin/grep smartctl | /bin/grep Copyright | /usr/bin/cut -d ' ' -f 3`;
# checking for new version
my $addonname = 'hddgraph';
my $onlineversion = '';
my $onlinelink = '';
my $timestamplastcheck = '/var/ipcop/hddgraph/lastcheck';
my $flagdonotcheck = '/var/ipcop/hddgraph/noversioncheck';


my %cgiparams=();
my @cgigraphs=();
my @graphs=();

&Header::showhttpheaders();

my $graphdir = "/home/httpd/html/graphs";

$ENV{'QUERY_STRING'} =~ s/&//g;
@cgigraphs = split(/graph=/,$ENV{'QUERY_STRING'});
$cgigraphs[1] = '' unless defined $cgigraphs[1];

&Header::openpage($Lang::tr{'harddisk temperature graphs'}, 1, '');

&Header::openbigbox('100%', 'left');

#
# Check for new version
#
&checkfornewversion($addonname, $version);
if ( $onlineversion ne '' )
{
  &Header::openbox('100%', 'left', $Lang::tr{'info'});
  print <<END
<table width="100%"><tr>
<td>$Lang::tr{'hddgraph newversion'} <a href="$onlinelink" target="_blank"><b>$onlineversion</b></a></td>
</tr></table>
END
;
  &Header::closebox();
}


&Header::openbox('100%', 'center', $Lang::tr{'harddisk temperature'});

if (-e "$graphdir/hddtemp-day.png") 
{
  my $ftime = localtime((stat("$graphdir/hddtemp-day.png"))[9]);
  print "<center>";
  print "<b>$Lang::tr{'the statistics were last updated at'}: $ftime</b></center><br /><hr />\n";
  print "<img src='/graphs/hddtemp-day.png' border='0' /><hr />";
  print "<img src='/graphs/hddtemp-week.png' border='0' /><hr />";
  print "<img src='/graphs/hddtemp-month.png' border='0' /><hr />";
  print "<img src='/graphs/hddtemp-year.png' border='0' />";
}
else 
{
  print $Lang::tr{'no information available'};
}
  
print "<br /><hr /><table width='100%'>";
if ( $hddtempversion ne '' ) 
{
  print "<tr><td>&nbsp;</td><td align='right'><b><small><a href='http://www.ipadd.de/binary.html' target='_blank'>HDDTemp $hddtempversion</a></small></b></td></tr>";
}
if ( $smartctlversion ne '' ) 
{
  print "<tr><td>&nbsp;</td><td align='right'><b><small><a href='http://www.ipadd.de/binary.html' target='_blank'>Smartctl $smartctlversion</a></small></b></td></tr>";
}
print "<tr><td>&nbsp;</td><td align='right'><b><small><a href='http://www.ban-solms.de/t/IPCop.html' target='_blank'>HDD Graph $version</a></small></b></td></tr></table>";

&Header::closebox();

if ( -e "/var/log/hddgraph_smartctl_out" ) 
{
  &Header::openbox('100%', 'left', $Lang::tr{'harddisk status'});

  my $output = `/bin/cat /var/log/hddgraph_smartctl_out`;
	$output = &Header::cleanhtml($output);
  print "<pre>$output</pre>\n";
  &Header::closebox();
}

&Header::closebigbox();
&Header::closepage();


sub checkfornewversion
{
  my $addon = shift;
  my $version = shift;
  $onlineversion = '';

  if ( -e $flagdonotcheck )
  {
    return;
  }

  # only check if we are online and last check was some time ago
  if ( (! -e '/var/ipcop/red/active') || (-e $timestamplastcheck) && (int(-M $timestamplastcheck) < 5) )
  {
    return;
  }

#workaround to suppress a warning when a variable is used only once
  my @dummy = ( $General::version );
  undef (@dummy);

  my $ua = LWP::UserAgent->new;
  $ua->timeout(120);
  $ua->agent("Mozilla/4.0 (compatible; IPCop $General::version; $version)");
  my $content = $ua->get("http://ipcop-addons.ath.cx/version/$addon");

  if ( $content->is_success )
  {
    # compare the versions, format is v1.2.3
    $content->content =~ /v(\d+).(\d+).(\d+)/;
    my $ver1 = $1;
    my $ver2 = $2;
    my $ver3 = $3;

    $version =~ /v(\d+).(\d+).(\d+)/;

    if ( ($ver1 > $1) || (($ver1 == $1) && ($ver2 > $2)) || (($ver1 == $1) && ($ver2 == $2) && ($ver3 > $3)) )
    {
      $onlineversion = "v$ver1.$ver2.$ver3";

      $content->content =~ /http(.*)/;
      $onlinelink = "http$1";
    }
    else
    {
      # no news, recheck in a couple of days
      system("touch $timestamplastcheck");
    }
  }
}
